﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Reflection;

using ICSharpCode.SharpZipLib.Zip;

namespace Pitt_Lab_Printer_Setup
{
    internal class Extractor
    {
        private static Stream getStreamByName(string name)
        {
            Assembly asm = Assembly.GetExecutingAssembly();
            name = "Pitt_Lab_Printer_Setup.Resources." + name;
            return asm.GetManifestResourceStream(name);
        }

        public static void WriteResourceToProgFiles(string resName) {
            using (Stream sw = File.OpenWrite(Path.Combine(Paths.PLPProgramFiles, resName)))
            {
                using (Stream inStr = getStreamByName(resName))
                {
                    connectStreams(inStr, sw);
                }
            }
        }

        private static void connectStreams(Stream inStr, Stream outStr)
        {
            int a;
            byte[] bytes = new byte[16384];
            do
            {
                a = inStr.Read(bytes, 0, bytes.Length);
                if (a > 0)
                {
                    outStr.Write(bytes, 0, a);
                }
            } while (a > 0);
        }

        public static void Extract(string name, string destPath)
        {
            string tempFile;
            using (Stream baseStream = getStreamByName(name))
            {
                tempFile = Path.GetTempFileName();
                using (Stream sw = File.OpenWrite(tempFile))
                {
                    connectStreams(baseStream, sw);
                }
            }

            FastZip zip = new FastZip();
            zip.ExtractZip(tempFile, destPath, String.Empty);
            File.Delete(tempFile);
        }

    }
}
