﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Pitt_Lab_Printer_Setup
{
    internal class InstallLogger
    {
        private StreamWriter log;

        private static InstallLogger instance = null;

        private InstallLogger()
        {
            log = new StreamWriter(Path.Combine(Environment.GetEnvironmentVariable("USERPROFILE"), "plp_install.log"), false);
        }

        public static InstallLogger Instance
        {
            get
            {
                if (instance != null)
                {
                    if (instance.log == null)
                    {
                        instance.log = new StreamWriter(Path.Combine(Environment.GetEnvironmentVariable("USERPROFILE"), "plp_install.log"), false);
                    }
                }
                else
                {
                    instance = new InstallLogger();
                }
                return instance;
            }
        }

        public void Write(string str)
        {
            string timeStamp = DateTime.Now.ToString();
            this.log.WriteLine(timeStamp + "\t" + str);
            this.log.Flush();
        }

        public void Close()
        {
            this.log.Close();
            this.log = null;
        }

    }
}
