﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Runtime.InteropServices;

namespace Pitt_Lab_Printer_Setup
{
    internal class Paths
    {

        private const int CSIDL_COMMON_PROGRAMS = 0x17; // ID for Programs folder in All Users's Start Menu
        private const int MAX_PATH_LENGTH = 260;

        public static string PLPProgramFiles
        {
            get
            {
                return Path.Combine(Paths.ProgramFiles, "Pitt Lab Printer");
            }
        }

        public static string ProgramFiles
        {
            get
            {
                return Environment.GetEnvironmentVariable("PROGRAMFILES");
            }
        }

        [DllImport("shell32.dll")]
        private static extern bool SHGetSpecialFolderPath(IntPtr hwndOwner,
           [Out] StringBuilder lpszPath, int nFolder, bool fCreate);

        public static string StartMenuProgramsPath
        {
            get
            {
                StringBuilder sb = new StringBuilder(MAX_PATH_LENGTH);
                if (!SHGetSpecialFolderPath(IntPtr.Zero, sb, CSIDL_COMMON_PROGRAMS, false)) // if it fails try an alternate way
                {
                    return Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.StartMenu), "Programs");
                }
                return sb.ToString();
            }
        }

    }
}
