using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Win32;
using System.Diagnostics;
using System.IO;

namespace Pitt_Lab_Printer_Setup
{
    internal class PrinterRemover
    {
        public static bool RemovePort()
        {
            RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SYSTEM\CurrentControlSet\Control\Print\Monitors\Redirected Port\Ports",true);
            try
            {
                key.DeleteSubKeyTree("PLP:");
            }
            catch (Exception) { }
            return true;
        }

        public static bool RemovePrinter()
        {
            Process p = new Process();
            p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            p.StartInfo.FileName = "rundll32.exe";
            p.StartInfo.Arguments = "printui.dll,PrintUIEntry /dl /n \"Pitt Lab Printer\"";
            try
            {
                p.Start();
                p.WaitForExit();
            }
            catch (Exception) { }
            return true;
        }

        public static bool RemoveShortcuts()
        {
            string s = Path.Combine(Paths.StartMenuProgramsPath, "Pitt Lab Printer");
            if (!Directory.Exists(s))
            {
                return true;
            }
            Directory.Delete(s, true);
            return true;
        }

        public static bool RemoveRedmon()
        {
            RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SYSTEM\CurrentControlSet\Control\Print\Monitors\Redirected Port\Ports", false);
            if (key != null)
            {
                if (key.GetSubKeyNames().Length > 0)
                {
                    return false;
                }
            }
            Process p = new Process();
            p.StartInfo.FileName= Path.Combine(Paths.PLPProgramFiles, @"redmon\unredmon.exe");
            p.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            p.StartInfo.Arguments = "/quiet";
            try
            {
                p.Start();
                p.WaitForExit();
            }
            catch (Exception) { }
            return true;
        }

        public static bool RemoveFolder()
        {
            RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce", true);
            String cmd = Environment.GetEnvironmentVariable("COMSPEC") + " /c \"rmdir \"" + Paths.PLPProgramFiles + "\" /S /Q\"";
            key.SetValue("PLPUninstall", cmd);
            return true;
        }

        public static bool RemoveUninstallKeys()
        {
            RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall", true);
            try
            {
                key.DeleteSubKeyTree("Pitt Lab Printer");
            }
            catch (Exception) { }
            return true;
        }

    }
}
