using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Security.Principal;
using System.Runtime.InteropServices;
using Microsoft.Win32;

namespace Pitt_Lab_Printer_Setup
{
    public enum Architecture { X86, X64 };

    internal class Utilities
    {

        public static bool IsAdmin
        {
            get
            {
                return new WindowsPrincipal(WindowsIdentity.GetCurrent()).IsInRole(WindowsBuiltInRole.Administrator);
            }
        }

        public static Architecture GetArchitecture()
        {
            if (IntPtr.Size == 4) // 32-bit
            {
                return Architecture.X86;
            }
            return Architecture.X64;
        }

        public static bool IsCompatibleOS
        {
            get
            {
                return Environment.OSVersion.Version.Major > 4;
            }
        }

        public static bool IsPrinterInstalled()
        {
            return (Registry.LocalMachine.OpenSubKey(@"SYSTEM\CurrentControlSet\Control\Print\Printers\Pitt Lab Printer", false) != null);
        }

        public static bool IsRebootPending()
        {
            RegistryKey key = Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce", false);
            return (key.GetValue("PLPUninstall") != null);
        }

    }
}
